using System;

namespace Busqueda_Binaria{
	class Principal{
		[STAThread]
		//Ejercicio que realiza busqueda binaria.
		static void Main(){
			int[] arreglo;
			int band=0,dim=0;
			Console.Write("\t\tBienvenido al programa de Bsqueda Binaria!\n");
			do{
				try{
					Console.Write("\nIngrese la dimensin del arreglo: ");
					dim=int.Parse(Console.ReadLine());
					band=0;
				}catch (System.FormatException e){
					Console.Write(e.Message.ToString());
					band=1;
				}
			}while(band!=0);
			arreglo=new int[dim];
			Principal.Cargar(arreglo,dim);
			Principal.Ordenar(arreglo,dim);
			Console.Read();
			return;
		}

		//Funcin cargar datos
		static void Cargar(int[] arreglo,int dim){
			int band=0;
			do{
				try{
					for (int i=0;i<dim;i++){
						Console.Write("\nIngrese el valor que desee(en nmeros enteros): ");
						arreglo[i]=int.Parse(Console.ReadLine());
						band=0;
					}
				}catch (System.Exception e){
					Console.Write(e.Message.ToString());
					band=1;
				}
			}while(band!=0);
			Console.Write("\nEl arreglo desordenado es:");
			for (int i=0;i<dim;i++){
				Console.Write(" - "+arreglo[i]);
			}
		}

		//Funcin ordenar datos por mtodo burbuja(el ms sencillo)
		static void Ordenar(int[] v,int dim ){
			int aux=0;
			for (int i=0;i<dim;i++){
				for (int j=0;j<(dim-1);j++){
					if(v[i]<v[j]){
						aux=v[i];
						v[i]=v[j];
						v[j]=aux;
					}
				}
			}
			Console.Write("\nEl arreglo ordenado es: ");
			for (int i=0;i<dim;i++){
				Console.Write(v[i]);
			}
			Principal.Buscar(v,dim);
		}

		//Funcin Buscar valor
		static void Buscar(int[] arreglo,int dim){
			int valor=0,posicion=0;
			try{
				Console.Write("\nIngrese el valor a buscar, que se encuantra en el arreglo ordenado: ");
				valor=int.Parse(Console.ReadLine());
				posicion=Principal.BusBin(arreglo,valor,1,dim,posicion);
				Console.Write(posicion);
				if (posicion!=-1){
					Console.Write("\nLa posicin de "+valor+" es: "+(posicion+1)+"\n");
				}else Console.Write("\nBsqueda sin exito!\n No existe el elemento");
			}catch(System.FormatException e){Console.Write("\n"+e.Message.ToString());}
		
		}

		//Funcin Realizar Bsqueda Binaria
		static int BusBin(int[] v,int valor,int inf,int sup,int posicion){
			int mitad;
			try{
				if ((inf >= sup) && (v[inf]!= valor)){
					Console.Write("\nBsqueda sin exito!");
					posicion=(-1);
				}
			else {
				mitad=(inf+sup)/2;
				if (v[mitad]==valor){
					Console.Write("\nBsqueda con xito!");
					posicion=mitad;
				}
				else{
					//Si lo que se busca es mayor a la mitad se busca a la derecha del arreglo.
					if (valor>v[mitad]){
						Principal.BusBin(v,valor,mitad+1,sup,posicion);
					}
					else{ //Si lo que se busca es menor a la mitad se busca a la izquierda del arreglo.
						Principal.BusBin(v,valor,inf,mitad-1,posicion);
					}
				}
			}
			}catch(System.IndexOutOfRangeException){
				Console.Write("\nNo existe el elemento en el vector!!!");
				Console.Write(" Intente con otro nmero");
			}
			return posicion;
		}
	}
}
